/*========================== begin_copyright_notice ============================

Copyright (C) 2017-2021 Intel Corporation

SPDX-License-Identifier: MIT

============================= end_copyright_notice ===========================*/

//*****************************************************************************/
// Generic Header
//*****************************************************************************/
#include "IBiF_Header.cl"

//*****************************************************************************/
// Math builtin functions
//*****************************************************************************/
#include "IBiF_Math_Common.cl"

//*****************************************************************************/
// Arithmetic opcodes
//*****************************************************************************/
#include "arithmetic.cl"

//*****************************************************************************/
// Atomics opcodes
//*****************************************************************************/
#include "atomics.cl"

//*****************************************************************************/
// Barrier opcodes
//*****************************************************************************/
#include "barrier.cl"


//*****************************************************************************/
// Bits opcodes
//*****************************************************************************/
#include "bits.cl"

//*****************************************************************************/
// Bits opcodes
//*****************************************************************************/
#include "conversions.cl"

//*****************************************************************************/
// Device-Side Enqueue opcodes
//*****************************************************************************/
#include "device_side_enqueue.cl"

//*****************************************************************************/
// Group opcodes
//*****************************************************************************/
#include "group.cl"

//*****************************************************************************/
// Group sort devicelib functions
//*****************************************************************************/
//#include "group_sort.cl"

#ifndef OMIT_IMAGES_CL_INCLUDE
//*****************************************************************************/
// Image opcodes
//*****************************************************************************/
#include "images.cl"
#endif // OMIT_IMAGES_CL_INCLUDE

//*****************************************************************************/
// Pipe opcodes
//*****************************************************************************/
#include "pipe.cl"

//*****************************************************************************/
// Prefetch opcodes
//*****************************************************************************/
#include "prefetch.cl"

//*****************************************************************************/
// Relational opcodes
//*****************************************************************************/
#include "relational.cl"

//*****************************************************************************/
// Shuffle opcodes
//*****************************************************************************/
#include "shuffle.cl"

//*****************************************************************************/
// Vload opcodes
//*****************************************************************************/
#include "vload.cl"

//*****************************************************************************/
// Vstore opcodes
//*****************************************************************************/
#include "vstore.cl"

//*****************************************************************************/
// 64bit Math Emulation
//*****************************************************************************/
#ifdef __IGC_BUILD__
#include "IGCBiF_Math_64bitDiv.cl"
#endif

//*****************************************************************************/
// Read Clock Extension Opcodes
//*****************************************************************************/
#include "clock.cl"

//*****************************************************************************/
// Tile ID Extension Opcodes
//*****************************************************************************/
#include "tileid.cl"

//*****************************************************************************/
// Assert implementation
//*****************************************************************************/
#include "assert.cl"
